#ifndef __phasertng_table_infobits_class__
#define __phasertng_table_infobits_class__
#include <map>

namespace phasertng {
namespace table {

class expectedInfoBitsCen
{
  // For centrics, log(information in bits) as a function of log(sigesq) is
  // given below.
  const std::map<double,double> loginfobits = {
    {-13.8155, 2.94396}, {-13.693, 2.93464}, {-13.5704, 2.9251},
    {-13.4479, 2.91575}, {-13.3254, 2.90607}, {-13.2028, 2.89645},
    {-13.0803, 2.88668}, {-12.9578, 2.87679}, {-12.8353, 2.86685},
    {-12.7127, 2.85677}, {-12.5902, 2.84663}, {-12.4677, 2.83637},
    {-12.3451, 2.82599}, {-12.2226, 2.81551}, {-12.1001, 2.80493},
    {-11.9775, 2.79424}, {-11.855, 2.78344}, {-11.7325, 2.77252},
    {-11.6099, 2.76146}, {-11.4874, 2.75029}, {-11.3649, 2.73899},
    {-11.2423, 2.72757}, {-11.1198, 2.71603}, {-10.9973, 2.70434},
    {-10.8747, 2.6925}, {-10.7522, 2.68052}, {-10.6297, 2.66842},
    {-10.5071, 2.65616}, {-10.3846, 2.64373}, {-10.2621, 2.63118},
    {-10.1395, 2.61845}, {-10.017, 2.60556}, {-9.89447, 2.59248},
    {-9.77194, 2.57926}, {-9.64941, 2.56584}, {-9.52688, 2.55226},
    {-9.40434, 2.5385}, {-9.28181, 2.52453}, {-9.15928, 2.51037},
    {-9.03675, 2.496}, {-8.91421, 2.48143}, {-8.79168, 2.46666},
    {-8.66915, 2.45163}, {-8.54662, 2.43644}, {-8.42409, 2.42099},
    {-8.30155, 2.40527}, {-8.17902, 2.38933}, {-8.05649, 2.37317},
    {-7.93396, 2.35673}, {-7.81142, 2.34}, {-7.68889, 2.32303},
    {-7.56636, 2.30578}, {-7.44383, 2.28822}, {-7.32129, 2.27035},
    {-7.19876, 2.25216}, {-7.07623, 2.23365}, {-6.9537, 2.21489},
    {-6.83116, 2.19572}, {-6.70863, 2.17619}, {-6.5861, 2.15632},
    {-6.46357, 2.13608}, {-6.34103, 2.11538}, {-6.2185, 2.09431},
    {-6.09597, 2.07283}, {-5.97344, 2.05097}, {-5.85091, 2.02859},
    {-5.72837, 2.00566}, {-5.60584, 1.98233}, {-5.48331, 1.9585},
    {-5.36078, 1.93412}, {-5.23824, 1.90916}, {-5.11571, 1.88364},
    {-4.99318, 1.85751}, {-4.87065, 1.83085}, {-4.74811, 1.80335},
    {-4.62558, 1.77528}, {-4.50305, 1.7465}, {-4.38052, 1.71703},
    {-4.25798, 1.68667}, {-4.13545, 1.65554}, {-4.01292, 1.62359},
    {-3.89039, 1.59053}, {-3.76785, 1.55669}, {-3.64532, 1.52194},
    {-3.52279, 1.48607}, {-3.40026, 1.449}, {-3.27772, 1.41072},
    {-3.15519, 1.37127}, {-3.03266, 1.33065}, {-2.91013, 1.28838},
    {-2.7876, 1.24501}, {-2.66506, 1.19983}, {-2.54253, 1.1532},
    {-2.42, 1.10475}, {-2.29747, 1.05414}, {-2.17493, 1.00139},
    {-2.0524, 0.947502}, {-1.92987, 0.890337}, {-1.80734, 0.831376},
    {-1.6848, 0.769481}, {-1.56227, 0.704617}, {-1.43974, 0.63704},
    {-1.31721, 0.566381}, {-1.19467, 0.49153}, {-1.07214, 0.413909},
    {-0.949609, 0.331876}, {-0.827077, 0.245057}, {-0.704545, 0.15471},
    {-0.582012, 0.0585951}, {-0.45948, -0.0420209}, {-0.336947, -0.149253},
    {-0.214415, -0.262749}, {-0.0918827, -0.382962}, {0.0306497, -0.510354},
    {0.153182, -0.645387}, {0.275714, -0.788506}, {0.398247, -0.940118},
    {0.520779, -1.10057}, {0.643312, -1.2701}, {0.765844, -1.44884},
    {0.888376, -1.63672}, {1.01091, -1.83348}, {1.13344, -2.03865},
    {1.25597, -2.25151}, {1.37851, -2.47118}, {1.50104, -2.69663},
    {1.62357, -2.92679}, {1.7461, -3.16066}, {1.86864, -3.39736},
    {1.99117, -3.63615}, {2.1137, -3.8765}, {2.23623, -4.11799},
    {2.35877, -4.36033}, {2.4813, -4.6033}, {2.60383, -4.84676},
    {2.72636, -5.09058}, {2.84889, -5.33468}, {2.97143, -5.579},
    {3.09396, -5.82348}, {3.21649, -6.06809}, {3.33902, -6.3128},
    {3.46156, -6.55759}, {3.58409, -6.80244}, {3.70662, -7.04733},
    {3.82915, -7.29227}, {3.95169, -7.53723}, {4.07422, -7.78221},
    {4.19675, -8.02722}, {4.31928, -8.27223}, {4.44182, -8.51726},
    {4.56435, -8.76229}
  };

  public:
  double get(double sigesq)
  {
    phaser_assert(sigesq > 0);
    double logsig = std::log(sigesq);
    // For very small sigesq beyond table, cap information content
    if (logsig <= loginfobits.begin()->first)
      return std::exp(loginfobits.begin()->second);
    // For very large sigesq beyond table, use linear extrapolation formula
    if (logsig >= loginfobits.rbegin()->first)
    {
      double arg = std::max(0.366107 - 1.99993 * logsig,-70.);
      return std::exp(arg);
    }
    // Interpolate within table bounds
    double i1 = loginfobits.begin()->first;
    double s1 = loginfobits.begin()->second;
    double i2 = loginfobits.begin()->first;
    double s2 = loginfobits.begin()->second;
    for (auto item : loginfobits)
    {
      if (logsig < item.first)
      {
        i2 = item.first;
        s2 = item.second;
        break;
      }
      i1 = item.first;
      s1 = item.second;
    }
    double val(s1 + (logsig-i1)*(s2-s1)/(i2-i1));
    return std::exp(val);
  }
};

class expectedInfoBitsAcen
{
  // For acentrics, log(information in bits) as a function of log(sigesq) is
  // given below.
  const std::map<double,double> loginfobits = {
    {-13.8155, 2.95792}, {-13.7007, 2.9493}, {-13.586, 2.94062},
    {-13.4712, 2.93185}, {-13.3564, 2.92301}, {-13.2416, 2.91409},
    {-13.1268, 2.90509}, {-13.0121, 2.896}, {-12.8973, 2.88683},
    {-12.7825, 2.87758}, {-12.6677, 2.86824}, {-12.553, 2.85882},
    {-12.4382, 2.8493}, {-12.3234, 2.8397}, {-12.2086, 2.83},
    {-12.0938, 2.8202}, {-11.9791, 2.81031}, {-11.8643, 2.80032},
    {-11.7495, 2.79023}, {-11.6347, 2.78003}, {-11.5199, 2.76973},
    {-11.4052, 2.75933}, {-11.2904, 2.74881}, {-11.1756, 2.73819},
    {-11.0608, 2.72744}, {-10.9461, 2.71659}, {-10.8313, 2.70561},
    {-10.7165, 2.69451}, {-10.6017, 2.68329}, {-10.4869, 2.67194},
    {-10.3722, 2.66046}, {-10.2574, 2.64885}, {-10.1426, 2.6371},
    {-10.0278, 2.62521}, {-9.91306, 2.61318}, {-9.79828, 2.60101},
    {-9.6835, 2.58868}, {-9.56872, 2.5762}, {-9.45394, 2.56356},
    {-9.33917, 2.55077}, {-9.22439, 2.53781}, {-9.10961, 2.52467},
    {-8.99483, 2.51137}, {-8.88005, 2.49789}, {-8.76528, 2.48422},
    {-8.6505, 2.47037}, {-8.53572, 2.45632}, {-8.42094, 2.44208},
    {-8.30616, 2.42763}, {-8.19139, 2.41297}, {-8.07661, 2.3981},
    {-7.96183, 2.383}, {-7.84705, 2.36768}, {-7.73227, 2.35212},
    {-7.6175, 2.33632}, {-7.50272, 2.32027}, {-7.38794, 2.30396},
    {-7.27316, 2.28739}, {-7.15838, 2.27055}, {-7.04361, 2.25342},
    {-6.92883, 2.236}, {-6.81405, 2.21829}, {-6.69927, 2.20026},
    {-6.58449, 2.18191}, {-6.46972, 2.16323}, {-6.35494, 2.1442},
    {-6.24016, 2.12482}, {-6.12538, 2.10508}, {-6.0106, 2.08495},
    {-5.89582, 2.06442}, {-5.78105, 2.04349}, {-5.66627, 2.02213},
    {-5.55149, 2.00032}, {-5.43671, 1.97806}, {-5.32193, 1.95188},
    {-5.20716, 1.92827}, {-5.09238, 1.90411}, {-4.9776, 1.87937},
    {-4.86282, 1.85402}, {-4.74804, 1.82803}, {-4.63327, 1.80138},
    {-4.51849, 1.77402}, {-4.40371, 1.74594}, {-4.28893, 1.71708},
    {-4.17415, 1.68742}, {-4.05938, 1.6569}, {-3.9446, 1.62548},
    {-3.82982, 1.59312}, {-3.71504, 1.55975}, {-3.60026, 1.52534},
    {-3.48549, 1.4898}, {-3.37071, 1.45308}, {-3.25593, 1.41512},
    {-3.14115, 1.37582}, {-3.02637, 1.33511}, {-2.9116, 1.29291},
    {-2.79682, 1.24911}, {-2.68204, 1.20362}, {-2.56726, 1.15632},
    {-2.45248, 1.10708}, {-2.33771, 1.05579}, {-2.22293, 1.00228},
    {-2.10815, 0.946417}, {-1.99337, 0.888018}, {-1.87859, 0.826901},
    {-1.76382, 0.762868}, {-1.64904, 0.695699}, {-1.53426, 0.625159},
    {-1.41948, 0.550991}, {-1.3047, 0.472919}, {-1.18992, 0.390644},
    {-1.07515, 0.303849}, {-0.960369, 0.212192}, {-0.845591, 0.115314},
    {-0.730813, 0.0128388}, {-0.616034, -0.0956214}, {-0.501256, -0.210461},
    {-0.386478, -0.332069}, {-0.2717, -0.460823}, {-0.156922, -0.597066},
    {-0.0421442, -0.741095}, {0.0726338, -0.893134}, {0.187412, -1.05331},
    {0.30219, -1.22164}, {0.416968, -1.39798}, {0.531746, -1.58204},
    {0.646524, -1.77336}, {0.761302, -1.97132}, {0.87608, -2.1752},
    {0.990858, -2.38418}, {1.10564, -2.59743}, {1.22041, -2.81418},
    {1.33519, -3.03371}, {1.44997, -3.25543}, {1.56475, -3.47886},
    {1.67953, -3.70362}, {1.7943, -3.92941}, {1.90908, -4.156},
    {2.02386, -4.38323}, {2.13864, -4.61094}, {2.25342, -4.83904},
    {2.36819, -5.06744}, {2.48297, -5.29609}, {2.59775, -5.52492},
    {2.71253, -5.7539}, {2.82731, -5.983}, {2.94209, -6.2122},
    {3.05686, -6.44147}, {3.17164, -6.6708}, {3.28642, -6.90017},
    {3.4012, -7.12959}
  };

  public:
  double get(double sigesq)
  {
    phaser_assert(sigesq > 0);
    double logsig = std::log(sigesq);
    // For very small sigesq beyond table, cap information content
    if (logsig <= loginfobits.begin()->first)
      return std::exp(loginfobits.begin()->second);
    // For very large sigesq beyond table, use linear extrapolation formula
    if (logsig >= loginfobits.rbegin()->first)
    {
      double arg = std::max(-0.327281 - 1.99987 * logsig,-70.);
      return std::exp(arg);
    }
    // Interpolate within table bounds
    double i1 = loginfobits.begin()->first;
    double s1 = loginfobits.begin()->second;
    double i2 = loginfobits.begin()->first;
    double s2 = loginfobits.begin()->second;
    for (auto item : loginfobits)
    {
      if (logsig < item.first)
      {
        i2 = item.first;
        s2 = item.second;
        break;
      }
      i1 = item.first;
      s1 = item.second;
    }
    double val(s1 + (logsig-i1)*(s2-s1)/(i2-i1));
    return std::exp(val);
  }
};

}}
#endif
